package com.agiledeveloper.game;

import org.junit.jupiter.api.Test;

import java.util.List;
import java.util.Map;
import java.util.Set;

import static org.junit.jupiter.api.Assertions.*;
import static com.agiledeveloper.game.CellState.*;
import static com.agiledeveloper.game.GameOfLife.*;
import static com.agiledeveloper.game.Cell.*;

public class GameOfLifeTest {
  //heck no
//  public void testGameOfLife() {
//    GameOfLife game = new GameOfLife();
//    game.setAlive(1, 1);
//    game.setAlive(1, 2);
//    game.setAlive(1, 3);
//    game.setAlive(2, 2);
//    game.setAlive(2, 3);
//    game.setAlive(2, 4);
//    game.setAlive(3, 3);
//    game.setAlive(3, 4);
//    game.setAlive(3, 5);
//    game.setAlive(4, 4);
//    game.setAlive(4, 5);
//    game.setAlive(4, 6);
//    game.setAlive(5, 5);
//    game.setAlive(5, 6);
//    game.setAlive(5, 7);
//    game.setAlive(6, 6);
//    game.setAlive(6, 7);
//    game.setAlive(6, 8);
//    game.setAlive(7, 7);
//    game.setAlive(7, 8);
//    game.setAlive(7, 9);
//    game.setAlive(8, 8);
//    game.setAlive(8, 9);
//    game.setAlive(8, 10);
//    game.setAlive(9, 9);
//    game.setAlive(9, 10);
//    game.setAlive(9, 11);
//    game.setAlive(10, 10);
//    game.setAlive(10, 11);
//    game.setAlive(10, 12);
//    game.setAlive(11, 11);
//    game.setAlive(11, 12);
//    game.setAlive(11, 13);
//    game.setAlive(12, 12);
//    game.setAlive(12, 13);
//    game.setAlive(12, 14);
//    game.setAlive(13, 13);
//    game.setAlive(13, 14);
//    game.setAlive(13, 15);
//    game.setAlive(14, 14);
//    game.setAlive(14, 15);
//    game.setAlive(14, 16);
//    game.setAlive(15, 15);
//    game.setAlive(15, 16);
//    game.setAlive(15, 17);
//    game.setAlive(16, 16);
//    game.setAlive(16, 17);
//    game.setAlive(16, 18

  @Test
  void canaryTest() {
    assertTrue(true);
  }

  //good try, but not happy with this
//  @Test
//  void cellWithFewerThanTwoLiveNeighborsDies() {
//    GameOfLife game = new GameOfLife();
//    game.setAlive(1, 1);
//    game.setAlive(1, 2);
//    game.setAlive(2, 2);
//
//    game.nextGeneration();
//
//    assertTrue(!game.isAlive(1, 1));
//  }

  //A little better than previous tests it created, but still far from where we need to be
//  @Test
//  void deadCellBehaveors() {
//    GameOfLife game = new GameOfLife();
//    game.setAlive(1, 1);
//    game.setAlive(1, 2);
//    game.setAlive(2, 2);
//
//    game.nextGeneration();
//
//    assertTrue(!game.isAlive(1, 1));
//  }

  @Test
  void deadCellBehavior() {
    assertAll(
      () -> assertEquals(DEAD, nextState(DEAD, 0)),
      () -> assertEquals(DEAD, nextState(DEAD, 1)),
      () -> assertEquals(DEAD, nextState(DEAD, 2)),
      () -> assertEquals(ALIVE, nextState(DEAD, 3)),
      () -> assertEquals(DEAD, nextState(DEAD, 5)),
      () -> assertEquals(DEAD, nextState(DEAD, 8))
    );
  }

  @Test
  void liveCellBehavior() {
    assertAll(
      () -> assertEquals(DEAD, nextState(ALIVE, 0)),
      () -> assertEquals(DEAD, nextState(ALIVE, 1)),
      () -> assertEquals(ALIVE, nextState(ALIVE, 2)),
      () -> assertEquals(ALIVE, nextState(ALIVE, 3)),
      () -> assertEquals(DEAD, nextState(ALIVE, 5)),
      () -> assertEquals(DEAD, nextState(ALIVE, 8))
    );
  }

  @Test
  void generateSignalsForACell_1_1() {
    assertEquals(
      List.of(
        cell(0, 0), cell(0, 1), cell(0, 2),
        cell(1, 0),                 cell(1, 2),
        cell(2, 0), cell(2, 1), cell(2, 2)
      ),
      generateSignalsForOneCell(cell(1, 1)).toList()
    );
  }

  @Test
  void generateSignalsForACell_2_2() {
    assertEquals(
      List.of(
        cell(1, 1), cell(1, 2), cell(1, 3),
        cell(2, 1),                 cell(2, 3),
        cell(3, 1), cell(3, 2), cell(3, 3)
      ),
      generateSignalsForOneCell(cell(2, 2)).toList()
    );
  }

  @Test
  void generateSignalsForASetOfNoCells() {
    assertEquals(
      List.of(),
      generateSignalsForCells(Set.of())
    );
  }

  @Test
  void generateSignalsForASetOfOneCell() {
    assertEquals(
      List.of(
        cell(0, 0), cell(0, 1), cell(0, 2),
        cell(1, 0),                 cell(1, 2),
        cell(2, 0), cell(2, 1), cell(2, 2)
      ),
      generateSignalsForCells(Set.of(cell(1, 1)))
    );
  }

  @Test
  void generateSignalsForASetOfTwoCells() {
    assertEquals(
      List.of(
        cell(0, 0), cell(0, 1), cell(0, 2),
        cell(1, 0),                 cell(1, 2),
        cell(2, 0), cell(2, 1), cell(2, 2),
        cell(1, 1), cell(1, 2), cell(1, 3),
        cell(2, 1),                 cell(2, 3),
        cell(3, 1), cell(3, 2), cell(3, 3)
      ),
      generateSignalsForCells(Set.of(cell(1, 1), cell(2, 2)))
    );
  }

  @Test
  void countSignalsForNoCells() {
    assertEquals(
      Map.of(),
      countSignals(List.of())
    );
  }

  @Test
  void countSignalsForOneCell() {
    assertEquals(
      Map.of(cell(1, 1), 1),
      countSignals(List.of(cell(1, 1))
    ));
  }

  @Test
  void countSignalsForTwoCells() {
    assertEquals(
      Map.of(cell(1, 1), 1, cell(2, 2), 1),
      countSignals(List.of(cell(1, 1), cell(2, 2))
    ));
  }

  @Test
  void countSignalsForThreeCells() {
    assertEquals(
      Map.of(cell(1, 1), 2, cell(2, 2), 1),
      countSignals(List.of(cell(1, 1), cell(2, 2), cell(1, 1))
    ));
  }

  @Test
  void nextGenerationForEmptyUniverse() {
    assertEquals(Set.of(), nextGeneration(Set.of()));
  }

  @Test
  void nextGenerationForOneCell() {
    assertEquals(Set.of(), nextGeneration(Set.of(cell(1, 1))));
  }

  @Test
  void nextGenerationForTwoCells() {
    assertEquals(Set.of(), nextGeneration(Set.of(cell(1, 1), cell(2, 2))));
  }

  @Test
  void nextGenerationForThreeCells() {
    assertEquals(Set.of(cell(1, 1), cell(2, 1), cell(1, 2), cell(2, 2)), nextGeneration(Set.of(cell(1, 1), cell(2, 2), cell(1, 2))));
  }

  @Test
  void nextGenerationForABlock() {
    assertEquals(Set.of(cell(1, 1), cell(1, 2), cell(2, 1), cell(2, 2)), nextGeneration(Set.of(cell(1, 1), cell(1, 2), cell(2, 1), cell(2, 2))));
  }

  @Test
  void nextGenerationForAHorizontalBlinker() {
    assertEquals(Set.of(cell(1, 2), cell(2, 2), cell(3, 2)), nextGeneration(Set.of(cell(2, 1), cell(2, 2), cell(2, 3))));
  }

  @Test
  void nextGenerationForAVerticalBlinker() {
    assertEquals(Set.of(cell(2, 1), cell(2, 2), cell(2, 3)), nextGeneration(Set.of(cell(1, 2), cell(2, 2), cell(3, 2))));
  }
}
